/* 
 * WorldWide File System
 * Copyright (c) 1992,1993 Youki Kadobayashi
 * Copyright (c) 1992,1993 Osaka University
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that the following conditions
 * are met:
 * 1. Both the copyright notice and this permission notice appear in
 *    all copies of the software, derivative works or modified versions,
 *    and any portions thereof, and that both notices appear in
 *    supporting documentation.
 * 2. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the Osaka University
 *      and its contributors.
 * 3. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE DEVELOPER ``AS IS'' AND OSAKA
 * UNIVERSITY DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
 * WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Osaka University requests users of this software to return to
 *
 *  Youki Kadobayashi
 *  Department of Information and Computer Sciences
 *  Osaka University, Toyonaka 560, Osaka, Japan
 *
 * any improvements or extensions that they make and grant Osaka
 * University the rights to redistribute these changes.
 */
/*
 * Bootstrap file system. Provide service address information.
 * Gross hack!  Talented ladies&gentlemen should not read further!
 */
static char *AtFSid = "$Header: bfs.c[109.0] Wed Nov 24 03:47:03 1993 youki-k@is.aist-nara.ac.jp saved $";

#include <string.h>	/* for strlen */
#include "wfs.h"
#include "util.h"
#include "global.h"

#if 0
wf_proto proto_host = {
	"host", host_getattr, err_getattr_miss,
	err_lookup, err_lookup_miss, err_readlink,
	host_read, err_read_miss, err_readdir, err_readdir_miss,
	err_getuda, err_keepalive, err_close, err_shutdown, 0
};

wf_proto proto_cwd = {
	"cwd", cwd_getattr, err_getattr_miss,
	err_lookup, err_lookup_miss, err_readlink,
	cwd_read, err_read_miss, err_readdir, err_readdir_miss,
	err_getuda, err_keepalive, err_close, err_shutdown, 0
};
#endif

wf_proto proto_fh = {
	"fh", fh_getattr, err_getattr_miss,
	err_lookup, err_lookup_miss, err_readlink,
	fh_read, err_read_miss, err_readdir, err_readdir_miss,
	err_getuda, err_keepalive, err_close, err_shutdown, 0
};

void
bfs_start()
{
#if 0
	wf_vol *host_volp, *cwd_volp;

	host_volp = vol_alloc();
	host_volp->id = WF_HOST_VOL_ID;
	host_volp->name = "host(fake)";
	host_volp->dir = "host(fake)";

	cwd_volp = vol_alloc();
	cwd_volp->id = WF_CWD_VOL_ID;
	cwd_volp->name = "cwd(fake)";
	cwd_volp->dir = "cwd(fake)";
#endif
	wf_vol *fh_volp;

	fh_volp = vol_alloc();
	fh_volp->id = WF_FH_VOL_ID;
	fh_volp->name = "fh(fake)";
	fh_volp->dir = "fh(fake)";
}

/*
 * We do bypass protocol switch here, since this kind of ugly hack is
 * only necessary in the NFS.
 */

static void
fake_attr(attrp, size, fhp)
fattr *attrp;
long size;
wf_fh *fhp;
{
	bzero(attrp, sizeof(*attrp));
	/* hostname in ASCIZ */
	attr_initfile(attrp, size);
	attrp->fsid = fhp->child_vol;
	attrp->fileid = fhp->file_id;
}

#if 0
void
host_fake(c)
wf_thrd *c;
{
	static wf_file file;
	fake_attr(&file.fattr, strlen(cs_hostname)+1, c->fhp);
	c->filep = &file;
}

void
host_getattr(c)
wf_thrd *c;
{
	host_fake(c);
	nfs_getattr_reply(c, WF_REP_OK);
}

void
host_read(c)
wf_thrd *c;
{
	static fattr attr;
	int namelen;

	namelen = strlen(cs_hostname)+1;
	fake_attr(&attr, namelen, c->fhp);
	nfs_read_reply(c, WF_REP_OK, &attr, namelen, cs_hostname);
}

void
cwd_getattr(c)
wf_thrd *c;
{
	int ret;
	ret = cwd_fake(c, c->fhp);
	nfs_getattr_reply(c, ret);
}

void
cwd_read(c)
wf_thrd *c;
{
	static fattr attr;
	wf_vol *nfs_volp;
	int namelen;
	char path[MAXPATHLEN];

	nfs_volp = vol_findid(c->fhp->parent_vol);
	if (nfs_volp == NULL) {
		nfs_read_reply(c, WF_ERR_STALE, 0, 0, 0);
		return;
	}
	c->dirp = dir_findcache(nfs_volp, c->fhp->child_dir);
	if (c->dirp == (wf_dir *)0) {
		nfs_read_reply(c, WF_ERR_STALE, 0, 0, 0);
		return;
	}
	namelen = strlen(nfs_volp->dir) + strlen(nfs_volp->name)
		+ strlen(c->dirp->name) + 3;
	fake_attr(&attr, namelen, c->fhp);
	sprintf(path, "%s/%s%s/", nfs_volp->dir,
		nfs_volp->name, c->dirp->name);
	nfs_read_reply(c, WF_REP_OK, &attr, namelen, path);
}

#endif

int
cwd_fake(c, fhp)
wf_thrd *c;
wf_fh *fhp;
{
	static wf_file file;
	wf_vol *nfs_volp;

	nfs_volp = vol_findid(fhp->parent_vol);
	if (nfs_volp == NULL) {
		return WF_ERR_STALE;
	}
	c->dirp = dir_findcache(nfs_volp, fhp->child_dir);
	if (c->dirp == (wf_dir *)0) {
		return WF_ERR_STALE;
	}
	fake_attr(&file.fattr, strlen(nfs_volp->dir)
		  + strlen(nfs_volp->name) + strlen(c->dirp->name) + 3, fhp);
	c->filep = &file;
	return WF_REP_OK;
}

#define FH_STRING_LEN	36
void
fh_fake(c)
wf_thrd *c;
{
	static wf_file file;
	fake_attr(&file.fattr, FH_STRING_LEN, c->fhp);
	c->filep = &file;
}

void
fh_getattr(c)
wf_thrd *c;
{
	fh_fake(c);
	nfs_getattr_reply(c, WF_REP_OK);
}

void
fh_read(c)
wf_thrd *c;
{
	fattr attr;
	char fh_string[FH_STRING_LEN];

	fake_attr(&attr, FH_STRING_LEN, c->fhp);
	sprintf(fh_string, "%08x.%08x.%08x.%08x",
		c->fhp->parent_vol, c->fhp->parent_dir,
		c->fhp->parent_vol, c->fhp->child_dir);
	/*
	 * we don't use child_vol here since it's WF_FH_VOL_ID, a fake.
	 */
	nfs_read_reply(c, WF_REP_OK, &attr, FH_STRING_LEN, fh_string);
}

