/* 
 * WorldWide File System
 * Copyright (c) 1992,1993 Youki Kadobayashi
 * Copyright (c) 1992,1993 Osaka University
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that the following conditions
 * are met:
 * 1. Both the copyright notice and this permission notice appear in
 *    all copies of the software, derivative works or modified versions,
 *    and any portions thereof, and that both notices appear in
 *    supporting documentation.
 * 2. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the Osaka University
 *      and its contributors.
 * 3. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE DEVELOPER ``AS IS'' AND OSAKA
 * UNIVERSITY DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
 * WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Osaka University requests users of this software to return to
 *
 *  Youki Kadobayashi
 *  Department of Information and Computer Sciences
 *  Osaka University, Toyonaka 560, Osaka, Japan
 *
 * any improvements or extensions that they make and grant Osaka
 * University the rights to redistribute these changes.
 */
/* $Header: global.h[109.0] Wed Nov 24 03:47:10 1993 youki-k@is.aist-nara.ac.jp saved $ */

/* network related information */
extern char		cs_hostname[];		/* my hostname */
extern char		*cs_domain;		/* my domain name */
extern struct in_addr	cs_ipaddr;		/* my IP address */
extern int		cs_nfsport;		/* my NFS port */
extern SVCXPRT		*nfsxprt;
extern SVCXPRT		*csxprt;

/* verbosity */
extern char		*cs_progname;		/* my program name */
extern char		*cs_topdir;		/* my top directory */
extern int		cs_world;		/* my world id */
extern int		cs_pid;			/* my process id */
extern int		cs_year;		/* this year */
extern int		cs_month;		/* this month */
extern int		cs_day;			/* day of month */
extern char		cs_date[];		/* "yymmdd" of today */
extern int		cs_serial;		/* action id of today */

/* internal state */
extern serv_state	cs_state;		/* my state */
extern int		select_intr_valid;
extern time_t		now;
extern time_t		next_softclock;
extern int		task_notify_todo;
extern int		foreground;
extern int		immediate_abort;

/* for debugging */
extern wf_req *cs_ftp_debug;

/* "public" buffer for interim purpose. go cheap here.. */
extern char		cs_databuf[];

/* protocol switches */
extern wf_proto		proto_root;
extern wf_proto		proto_ftp;
extern wf_proto		proto_ufs;
#if 0
extern wf_proto		proto_host;
extern wf_proto		proto_cwd;
#endif
extern wf_proto		proto_fh;

/* libc complementary */
extern int	sys_nerr;
extern char	*sys_errlist[];

#include "config.h"	/* platform-specific settings */
#ifndef __CEXTRACT__
#include "auto.h"	/* automatically generated by cextract */
#endif
