/* rps (resource pointer server) interaction */
/*
 * Copyright (c) 1992 Youki Kadobayashi, Osaka University
 * All rights reserved.
 *
 * Redistribution and reuse in source and binary forms, with or without
 * modification, are totally prohibited. Permission to use, copy and modify
 * this software and its documentation is hereby granted to WWFS alpha
 * testers only.
 *
 * THIS SOFTWARE IS PROVIDED BY THE DEVELOPER ``AS IS'' AND OSAKA
 * UNIVERSITY DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
 * WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Osaka University requests users of this software to return to
 *
 *  Youki Kadobayashi
 *  Department of Information and Computer Sciences
 *  Osaka University, Toyonaka 560, Japan
 *
 * any improvements or extensions that they make and grant Osaka
 * University the rights to redistribute these changes.
 */

#include "wfs.h"
#include "util.h"
#include "global.h"
#include "closure.h"

/* XXX */
void
rps_init()
{
	wf_vol *volp = vol_alloc();
	wf_srv *srvp;

	volp->name = malloc(16);
	strcpy(volp->name, "sh.wide");
	volp->id = 2L;
	srvp = srv_findcache("sh.wide.ad.jp");
	assert(srvp != NULL);
	vol_addsrv(volp, srvp);
	volp->nconn = 0;
	vol_save(volp);
}

void
rps_findid(c)
rps_findid_c *c;
{
	rps_callback_c *p;

	c->volp = vol_findid(2L);	/* XXX */
	assert(c->volp != NULL);
	p = ALLOC(rps_callback_c);
	p->volp = c->volp;
	p->args = c->funcargs;
	(*c->funcp)(p);
}

#if 0
wfs_vol *
rps_findid(c)
rps_findid_c *c;
{
	rps_callback_c *p;
	switch (c->step) {
	case 0:
		c->volp = vol_findid(c->child_vol);
		if (c->volp == NULL) {
			/* local vol cache missed. */
			if (rps_sock == 0)
				rps_conn_open();
			c->step = 1;
			so_callback(rps_sock, rps_findid, c);
			return;
		}
		break;
	case 1:
		c->step = 2;
		rps_send_findid(c->child_vol);
		so_callback(rps_sock, rps_findid, c);
		return;
	case 2:
		c->volp = rps_recv_findid();
	}
	p = malloc(sizeof (rps_callback_c));
	p->volp = c->volp;
	p->args = c->funcargs;
	(*c->funcp)(p);
}

rps_conn_open()
{
}

rps_conn_close()
{
}

rps_send_findid()
{
}

rps_recv_findid()
{
}

#endif
