#!/usr/local/bin/perl
#
# Domain Internet Groper, written in Perl.  5 minutes hack.
# Usage: dig.pl [-t type] [-c class] hostname
# NOTE:	Trailing dot is necessary -- domainname attached otherwise.
#	Type and class argument must be uppercase.
#
# Author: Youki Kadobayashi <youki@wide.ad.jp>
# This file is part of WWFS.
#

require 'resolv.pl';
require 'getopts.pl';
do Getopts('c:t:');

(@ARGV == 1) || die "$0: 1 args.";

# $res'options |= &RES_DEBUG;
# $res'options |= &RES_USEVC;

$ns = &res_open;
$q = &res_mkquery($ARGV[0],
	$opt_t ? $opt_t : "ANY",
	$opt_c ? $opt_c : "IN");
@resp = &res_send($ns, $q);

print "; Perl DiG\n";
print ";; QUESTIONS:\n";
print ";;\t", @resp[3],
	", type = ", &res'qtype_numtostr($resp[4]),
	", class = ", &res'qclass_numtostr($resp[5]), "\n";

print "\n;; ANSWERS:\n";
&print_records($resp[6], $resp[7]);
print "\n;; AUTHORITY RECORDS:\n";
&print_records($resp[8], $resp[9]);
print "\n;; ADDITIONAL RECORDS:\n";
&print_records($resp[10], $resp[11]);

sub print_records {
	local ($from, $to) = @_;

	for ($i = $from; $i < $to; $i += 5) {
		print $resp[$i], "\t", $resp[$i+1], "\t",  $resp[$i+2], "\t", $resp[$i+3], "\t", $resp[$i+4], "\n";
	}
}

