#!/usr/local/bin/perl
#
# gtr_test.pl -- sort hostnames by GTR.
#
# specify GTR preference in "/etc/gtr.conf".
# mimic DNS TXT GTR record by "/etc/gtr.txt".
#
# Author: Youki Kadobayashi <youki@wide.ad.jp>
#
require 'gtr.pl';
require 'getopts.pl';

do Getopts('d:');
$opt_d = "/etc" unless $opt_d;
$gtr'conf = "$opt_d/gtr.conf";
$gtr'txt = "$opt_d/gtr.txt";

# testing.
@hosts = ('sh.wide.ad.jp', 'ftp.iij.ad.jp', 'utsun.s.u-tokyo.ac.jp',
	  'ftp.center.osaka-u.ac.jp', 'ftp.ics.es.osaka-u.ac.jp');

@sorted = &gtr'sort(@hosts);

print join("\t", @sorted), "\n";

