/* 
 * WorldWide File System
 * Copyright (c) 1992,1993 Youki Kadobayashi
 * Copyright (c) 1992,1993 Osaka University
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that the following conditions
 * are met:
 * 1. Both the copyright notice and this permission notice appear in
 *    all copies of the software, derivative works or modified versions,
 *    and any portions thereof, and that both notices appear in
 *    supporting documentation.
 * 2. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the Osaka University
 *      and its contributors.
 * 3. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE DEVELOPER ``AS IS'' AND OSAKA
 * UNIVERSITY DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
 * WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Osaka University requests users of this software to return to
 *
 *  Youki Kadobayashi
 *  Department of Information and Computer Sciences
 *  Osaka University, Toyonaka 560, Osaka, Japan
 *
 * any improvements or extensions that they make and grant Osaka
 * University the rights to redistribute these changes.
 */
static char *AtFSid = "$Header: wwget.c[109.0] Wed Nov 24 03:49:16 1993 youki-k@is.aist-nara.ac.jp saved $";

#include <stdio.h>
#include "libww.h"

usage(name)
char *name;
{
	printf("Usage: %s [-v] files...\n", name);
	exit(1);
}

int vflag = 0;

main(argc, argv)
int argc;
char **argv;
{
	int c;
	extern int optind, opterr;
	extern char *optarg;

	while ((c = getopt(argc, argv, "v")) != EOF) {
		switch (c) {
		case 'v':
			vflag++;
			break;
		case '?':
			usage(argv[0]);
		}
	}
	for ( ; optind < argc; ++optind) {
		if (vflag) {
			printf("%s", argv[optind]);
			fflush(stdout);
		}
		ww_nfsget(argv[optind]);	/* RETR file via NFS+UIP */
		if (vflag) {
			putchar('\n');
		}
	}
	return (0);
}

