# dirutil: directory-related goodies
# Youki Kadobayashi <youki@wide.ad.jp>
# This file is part of WWFS.
#

sub basename {
    local ($pathname) = @_;
    local ($dir, $file, $pos);

    $pos = rindex($pathname, "/");
    if ($pos < 0) {
        return (".", $pathname);
    }
    ++$pos;
    ($dir, $file) = unpack("a$pos a*", $pathname);
    return ($dir, $file);
}

sub mkdirhier {
        local($dir) = @_;
        local($mk, @components);
        # four-line implementation
	@components = split (/\//, $dir);
	$mk = shift(@components);
        foreach $i (@components) {
                $mk .= "/" . $i;
		next if -d $mk;
                mkdir($mk, 0755) || warn "$mk: $!" && return undef;
        }
	1;
}

1;

# Local Variables:
# mode: perl
# End:
